import 'package:get/get.dart';
import 'package:getx_extended_dart/controller/export.dart';
import 'package:uuid/uuid.dart';

class TaskController extends GetxController with CountableController {
  List<dynamic> errors = [];

  Future<T> enqueue<T>(
    Future<T> Function() taskBuilder, {
    Duration autoComplete = const Duration(seconds: 5),
  }) {
    final uuid = Uuid().v4();
    add(uuid, autoComplete: autoComplete);
    return taskBuilder()
        .catchError(catchError)
        .whenComplete(() => complete(uuid));
  }

  dynamic catchError(error) {
    errors.add(error);
    return error;
  }

  void dismiss(dynamic error) => errors.remove(error);
}
