import 'dart:async';

import 'package:get/get.dart';

extension GetExtension<T> on Rx<T> {
  StreamSubscription<T> listenWithInitialValue(
    void Function(T data) onData,
  ) {
    final controller = StreamController<T>();

    final subscription = listen(controller.add);

    controller.onCancel = () {
      subscription.cancel();
    };

    onData(value);
    return controller.stream.listen(onData);
  }
}
